/** Rill v0.0.41 https://www.npmjs.com/package/rill License: MIT*/
var byteLength, empty, isType;

isType = require("./isType");

byteLength = require("./byteLength");

empty = {
  204: true,
  205: true,
  304: true
};

module.exports = function*(req, res, next) {
  var headers, response;
  (yield next);
  response = res.originalRes;
  headers = res.headers;
  if (response.headersSent) {
    return;
  }
  if (empty[res.status] || (res.body == null)) {
    headers["Content-Type"] = void 0;
    res.body = null;
  } else if (isType.String(res.body)) {
    if (headers["Content-Type"] == null) {
      headers["Content-Type"] = "text/" + (/^\s*</.test(res.body) ? "html" : "plain");
    }
  } else if (isType.Object(res.body)) {
    if (headers["Content-Type"] == null) {
      headers["Content-Type"] = "application/json";
    }
    res.body = JSON.stringify(res.body);
  } else {
    if (headers["Content-Type"] == null) {
      headers["Content-Type"] = "application/octet-stream";
    }
    if (res.body.length) {
      if (headers["Content-Length"] == null) {
        headers["Content-Length"] = res.body.length;
      }
    }
    if (isType.Stream(res.body)) {
      return res.body.pipe(response);
    }
  }
  if (headers["Content-Length"] == null) {
    headers["Content-Length"] = byteLength(res.body);
  }
  if (Number(res.status) === 404 && isType.empty(res.body)) {
    res.status = 200;
  }
  response.writeHead(res.status, res.headers);
  return response.end("HEAD" !== req.method ? res.body : void 0);
};
